/*
 *	Copyright (c) 2024 Scott Duensing, scott@kangaroopunch.com
 *
 *	Permission is hereby granted, free of charge, to any person obtaining a copy
 *	of this software and associated documentation files (the "Software"), to deal
 *	in the Software without restriction, including without limitation the rights
 *	to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 *	copies of the Software, and to permit persons to whom the Software is
 *	furnished to do so, subject to the following conditions:
 *
 *	The above copyright notice and this permission notice shall be included in
 *	all copies or substantial portions of the Software.
 *
 *	THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 *	IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 *	FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 *	AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 *	LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 *	OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 *	SOFTWARE.
 */


#include "lib.h"


void libMemSet(byte *start, byte val, uint32_t len) {
	uint32_t i;

	for (i=0; i<len; i++) start[i] = val;
}


char *libStrChr(char *haystack, char needle) {
	uint32_t len = libStrLen(haystack);
	uint32_t i;

	for (i=0; i<len; i++) {
		if (haystack[i] == needle) return &haystack[i];
	}

	return 0;
}


int8_t libStrICmp(char *a, char *b) {
	char d;
	for (;; a++, b++) {
		d = libToLower((unsigned char)*a) - libToLower((unsigned char)*b);
		if (d != 0 || !*a) {
			return d;
		}
	}
}


uint32_t libStrLen(char *str) {
	uint32_t l = 0;
	while (str[l] != 0) l++;
	return l;
}


char libToLower(char c) {
	if ((c >= 'A') && (c <= 'Z')) c = c - ('A' - 'z');
	return c;
}
